; calculate the image center by using the peak intensity
; IN  image : POINTER TO FLTARR(nx, ny, nz)   image cube
; IN  x     : FLOAT                           old center
; IN  y     : FLOAT                           old center
; IN  z     : FLOAT                           image plane
; OUT cx    : FLOAT                           new image center
; OUT cy    : FLOAT                           new image center
PRO LDRS_CALC_CENTER_PEAK, image, x, y, z, cx, cy, WINSIZE=ws
IF N_ELEMENTS(ws) EQ 0 THEN ws = 32
s = SIZE(image, /DIMENSIONS)
left   = FIX(x - ws)
right  = FIX(x + ws)
bottom = FIX(y - ws)
top    = FIX(y + ws)
IF left LT 0 THEN left = 0
IF right GE s[0] THEN right = s[0]-1
IF bottom LT 0 THEN bottom = 0
IF top GE s[1] THEN top = s[1]-1
w=right-left+1
h=top-bottom+1
ipart = image[left:right,bottom:top,z]
m = MAX(ipart, idx)
cx = left + idx MOD w
cy = bottom + idx / w
END

