; copy all important header keywords of a file into another file
; currently only inside the parameter file
; it is planned, that this information is also copied between FITS
; files
PRO LDRS_COPY_HEADER, fromFile, toFile
; safety checks
IF NOT OBJ_VALID(fromFile) THEN RETURN
IF NOT OBJ_VALID(toFile) THEN RETURN
; resize (load) the input file in order to get the number of images in
; that file
res = fromFile->Resize()
nz = fromFile->GetNImages()
; copy all file specific values
ffCFG = fromFile->GetFileCFG()
tfCFG = toFile->GetFileCFG()
IF OBJ_VALID(ffCFG) AND OBJ_VALID(tfCFG) THEN BEGIN
    ; observation wavelength (if available)
    cfg = ffCFG->Locate('OBS.LAMBDA', /NO_CREATE)
    IF OBJ_VALID(cfg) THEN tfCFG->SetFloat, 'OBS.LAMBDA', cfg->GetFloat('')
    cfg = ffCFG->Locate('OBS.DLAMBDA', /NO_CREATE)
    IF OBJ_VALID(cfg) THEN tfCFG->SetFloat, 'OBS.DLAMBDA', cfg->GetFloat('')
ENDIF
FOR z=0,nz-1 DO BEGIN
    fiCFG = fromFile->GetImageCFG(z)
    tiCFG = toFile->GetImageCFG(z)
    ; detector rotator angle (if available)
    cfg = fiCFG->Locate('OBS.ROTATOR', /NO_CREATE)
    IF OBJ_VALID(cfg) THEN tiCFG->SetFloat, 'OBS.ROTATOR', cfg->GetFloat('')
    ; image rotation angle (from preprocessing, if available)
    cfg = fiCFG->Locate('PREP.ROTATE', /NO_CREATE)
    IF OBJ_VALID(cfg) THEN tiCFG->SetFloat, 'PREP.ROTATE', cfg->GetFloat('')
ENDFOR
END

