FUNCTION ldrs_psf, r
IF r EQ 0.0 THEN RETURN, ldrs_psf(0.001)
RETURN, beselj(r, 1)/r
END

PRO LDRS_CREATE_PSF, nx, ny, pa, lambda, dlambda, psf
IF N_ELEMENTS(psf) EQ 0 THEN psf = FLTARR(nx, ny)
psf[*] = 0.0
PRINT, 'LDRS_CREATE_PSF,', nx, ny, pa, lambda, dlambda
;IF dlambda EQ 0.0 THEN BEGIN
    obs_lambda = lambda
;ENDIF ELSE BEGIN
;    obs_lambda = lambda - 0.5*dlambda
;ENDELSE
det_pix_size=18.0
rf  = obs_lambda/det_pix_size*32.57*22.8/8.4  ; scale factor for J1(r)
rh  = obs_lambda/det_pix_size*32.57*22.8/1.0  ; scale factor for J1(r)
af  = 1.236*obs_lambda/det_pix_size*32.57*14.4/22.8 ; scale factor for cos(a)
fh  = (0.5/4.2)^2
PRINT, '   rf = ', rf, ' rh = ', rh, ', af = ', af, ' fh = ', fh
cphi = cos(pa)
sphi = sin(pa)
FOR x=0,nx-1 DO BEGIN
    FOR y=0,ny-1 DO BEGIN
        dx = FLOAT(x - nx/2)
        dy = FLOAT(y - ny/2)
        r = sqrt(dx^2 + dy^2)
        IF r EQ 0.0 THEN BEGIN
            psf[x,y] = 0.5 - fh
            CONTINUE
        ENDIF
        a = cphi*dx + sphi*dy
        ;psf[x,y] = ldrs_psf(!PI*r/rf)^2
        psf[x,y] = (ldrs_psf(!PI*r/rf) - fh*ldrs_psf(!PI*r/rh))^2*(1 + cos(!PI*a/af))
    ENDFOR
ENDFOR
END

