FUNCTION LDRS_ENCODE_FILENAME, recName, fileName
;PRINT, 'LDRS_ENCODE_FILENAME, ', recName, ', ', fileName
recPath  = STRSPLIT(recName,  PATH_SEP(), /EXTRACT)
filePath = STRSPLIT(fileName, PATH_SEP(), /EXTRACT)
recPathLen  = N_ELEMENTS(recPath)
filePathLen = N_ELEMENTS(filePath)
comCount = 0
WHILE (comCount LT recPathLen) AND (comCount LT filePathLen) DO BEGIN
    IF recPath[comCount] NE filePath[comCount] THEN BREAK
    comCount++
ENDWHILE
;PRINT, '  the first ', comCount, ' directories are identical'
nUps   = recPathLen - comCount - 1
nDowns = filePathLen - comCount
;PRINT, '  nUps=', nUps, ', nDowns=', nDowns
IF (nUps + nDowns) EQ 0 THEN RETURN, ''
resPath = STRARR(nUps + nDowns)
IF nUps NE 0 THEN resPath[0:nUps - 1] = '..'
resPath[nUps:nUps+nDowns-1] = filePath[comCount:comCount+nDowns-1]
resFile = STRJOIN(resPath, PATH_SEP())
;PRINT, '  encoded: ', resFile
RETURN, resFile
END
