;# Algorithm
;MODULE<i>.ALGO<j>.TAG    = <string>  # unique algorithm tag
;MODULE<i>.ALGO<j>.LABEL  = <string>  # label used in the GUI
;MODULE<i>.ALGO<j>.CLASS  = <string>  # IDL class name (implementation)
FUNCTION ldrsALGORITHM::Init, module, cfg
self.module = module
self.recipe = self.module->GetRecipe()
self.tag = cfg->GetString('TAG')
self.label = cfg->GetString('LABEL')
self.className = cfg->GetString('CLASS', DEFAULT='')
RETURN, 1
END

FUNCTION ldrsALGORITHM::GetModule
RETURN, self.module
END

FUNCTION ldrsALGORITHM::GetTag
RETURN, self.tag
END

FUNCTION ldrsALGORITHM::GetLabel
RETURN, self.label
END

FUNCTION ldrsALGORITHM::GetClassName
RETURN, self.className
END

FUNCTION ldrsALGORITHM::GetImpl
IF NOT OBJ_VALID(self.impl) THEN self.impl = OBJ_NEW(self.className, self)
RETURN, self.impl
END

PRO ldrsALGORITHM::Edit, top
;PRINT, 'ldrsALGORITHM::Edit of ', self.className, ' called'
IF NOT OBJ_VALID(self.impl) THEN self.impl = OBJ_NEW(self.className, self)
self.impl->Edit, top
END

PRO ldrsALGORITHM::Execute
;PRINT, 'ldrsALGORITHM::Execute of ', self.className, ' called'
IF NOT OBJ_VALID(self.impl) THEN self.impl = OBJ_NEW(self.className, self)
self.impl->ExecuteAlgorithm, /ALL
END

PRO ldrsALGORITHM::Pause
;PRINT, 'ldrsALGORITHM::Pause of ', self.className, ' called'
IF NOT OBJ_VALID(self.impl) THEN self.impl = OBJ_NEW(self.className, self)
self.impl->Pause
END

PRO ldrsALGORITHM::Resume
;PRINT, 'ldrsALGORITHM::Resume of ', self.className, ' called'
IF NOT OBJ_VALID(self.impl) THEN self.impl = OBJ_NEW(self.className, self)
self.impl->Resume
END

PRO ldrsALGORITHM__define
struct = { ldrsALGORITHM, $
           recipe:OBJ_NEW(), $
           module:OBJ_NEW(), $
           tag:'', $
           label:'', $
           className:'', $
           impl:OBJ_NEW() $
         }
END
