FUNCTION ldrsDECONV_KHHBB::Init, algorithm
IF NOT self->ldrsBUILDINGBLOCK::Init(algorithm) THEN RETURN, 0
self.nIter = 20000
self.nstartblocks = 1000
self.negbkweight = 0.6
self.tuefradius = 109
self.filltype = 0
self.regAlgo = 2
self.lambda = 1
self.betaMP = '1.0; 2.0; 0.5'
self.beta = 2.0
self.snr = 20000.0
self.blockSizeMP = '0.4'
self.blockSize = 0.4
self.maskSizeMP = '100.0'
self.maskSize = 100.0
self.beta = 2.0
self.betaMP = '1.0; 2.0; 0.5'
self.potweight = 0.0
self.potweightMP = '0.0; 0.5; 1.0; 2.0'
self.cliplevel = 1.0
self.cliplevelMP = '1.0; 4.0'  
self.pIter = 1000
self.detsigma = 10
self.data_number = 0
self.pipe_pack_length = 0L
self.read_status = 0
self.error_received = 0
dists = [   'DISTFT', $
            'DISTFT2',$
            'DISTFT0ORIG', $
            'DISTFT0ORIG2', $
            'DISTPSI', $
            'DISTFTPSI', $
            'DISTFT2PSI', $
            'DISTCHI2REG', $
            'COMPACTNESS2', $
            'DISTDIST', $
            'DISTREK']         
self.distance_names = PTR_NEW(dists)
RETURN, 1
END

FUNCTION ldrsDECONV_KHHBB::Prepare
   PRINT, 'ldrsDECONV_KHHBB::Prepare'
   IF NOT self->ldrsBUILDINGBLOCK::Prepare() THEN RETURN, 0
      objFile = self.objFT->GetFile(0)
      objName = objFile->GetName()
      obj = objFile->GetData()
      cfg = objFile->GetImageCFG(0)
      objBgrd = cfg->GetFloat('BGRD', DEFAULT=0.0)
      psfFile = self.psfFT->GetFile(0)
      psf = psfFile->GetData()
      psfName = psfFile->GetName()

      ;PRINT, 'targetname = ', objName
      estimateName = objName
      bkstartName = objName
      ortsmaskName = "no"

      rimgFile = self.rimgFT->GetFile(0)
      rimgName = rimgFile->GetName()
      recName = self.recFile->GetName()
      self.nphot = TOTAL(*(obj))
      ; building the mask

      ftmaskName=STRING(FILE_DIRNAME(objName, /MARK_DIRECTORY), 'ftmask.fits')
      ftmask = FLTARR(self.nx, self.ny)
      
      ; create the fft mask from the psf
      s = SIZE(*(psf), /DIMENSIONS)
      fthmask = ABS(FFT(*(psf)))
      limit = MAX(fthmask)*self.maskSize/100.0
      fthmask = SHIFT(fthmask, s[0]/2, s[1]/2)
      index = WHERE(fthmask GT limit , count)
      PRINT, '  count = ', count
      IF count NE 0 THEN ftmask[index] = 1.0
      ftmask = ftmask[self.nx/2:self.nx-1,*]
      FITS_WRITE, ftmaskName, ftmask, /NO_ABORT, MESSAGE=msg
      IF msg NE '' THEN BEGIN
          PRINT, 'ldrsDECONV_KHHBB::Execute, ', ftmaskName, ' errmsg=', msg
          RETURN, 0
      ENDIF
      opt_output = 0
      IF(self.primresult EQ 2 OR self.primresult EQ 3 OR self.secresult NE 0) THEN opt_output = 1
      self.cmd_Line = STRING( FORMAT='("building_block -ortsmaskename ", A, " -bilname  ", A, " -psfname  ", A, " -bkstartname  ", A, " -estname  ", A, " -origname ", A, " -ftmaskname ", A, " -bkresultname ", A, " -xbg ", I, " -nit ", I, " -jlambda ", I, " -jreg ", I, " -startanzahl ", I, " -bkint ", F20, " -reksnr ", I, "  -printit ", I, " -type ", I, " -pipe_output ", I, " -opt_output", I, " -nphot ", F20, " -sigma ", F20, " -kl ", F, " -beta ", F, " -pot ", F, "")' , $
                        ortsmaskName, objName, psfName, bkstartName, estimateName, rimgName, ftmaskName, recName, $
                        self.tuefradius, $
                        self.nIter, $
                        self.lambda, $
                        self.regAlgo, $
                        self.nstartblocks, $
                        self.negbkweight, $
                        self.snr, $
                        self.pIter, $
                        self.filltype, $
                        2, $
                        opt_output, $
                        self.nphot, $
                        self.detsigma, $
                        self.cliplevel, $
                        self.beta, $
                        self.potweight)
      
RETURN, 1
END


FUNCTION ldrsDECONV_KHHBB::Process_stringdata
   ON_IOERROR, IO_FAILED

   string_array = STRARR(self.pipe_pack_length)
   singlechar = '0'
   FOR i=0L, (self.pipe_pack_length - 1) DO BEGIN
      READU, self.pipe, singlechar
      string_array[i] = singlechar
   ENDFOR
   comp_string = STRJOIN(string_array, /SINGLE)
   PRINT, 'C:> ', comp_string   
   
   IF( 0) THEN BEGIN
      IO_FAILED:
      PRINT, 'I/O failed in process string data'
      self.breakFlag = 1
      RETURN, -1
   ENDIF
   RETURN, 0
END

FUNCTION ldrsDECONV_KHHBB::ExecuteStep
; NOTE: There is a bug with the EOF function, which indicates if the pipe was closed
; by the other side.
; EOF can't be used with pipes. The Error don't occur at the Point where EOF is used.
; It shifts the read write pointer.
; If IDL reads AND writes EOF produces a shift in the read pipe.


   IF NOT self->ldrsDECONVOLVE::ExecuteStep() THEN RETURN, 0
   error = 0
   
    ON_IOERROR, IO_FAILED


   IF self.iIter EQ 1 THEN BEGIN
      PRINT, 'commandline which will be spawned = ', self.cmd_Line
      SPAWN, self.cmd_Line, UNIT=UNIT
      self.pipe = UNIT
      IF (self->read_tag() NE 0) THEN error = 1
   ENDIF ELSE BEGIN
      finish = 0
      IF (self.pauseFlag) THEN BEGIN
         IF(self->send_pipe('STOP', '') NE 0) THEN BEGIN
            error = 1
            finish = 1
            self.breakFlag = 1
         ENDIF
         self.pauseFlag = 0
      ENDIF
      WHILE(NOT finish) DO BEGIN
         IF (self.data_number GT self.iIter) THEN break
         IF(STRCMP(self.keyw_read, 'STOP') EQ 1) THEN BEGIN
            IF(self->Process_stringdata() NE 0) THEN error = 1
            finish = 1
         ENDIF
         IF(STRCMP(self.keyw_read, 'INFO') EQ 1) THEN BEGIN
            IF(self->Process_stringdata() NE 0) THEN BEGIN
               error = 1
               finish = 1
            ENDIF
         ENDIF
         IF(STRCMP(self.keyw_read, 'ERRO') EQ 1) THEN BEGIN
            IF(self->Process_stringdata() NE 0) THEN BEGIN
               error = 1
               finish = 1
            ENDIF
            self.error_received = 1
         ENDIF
         IF(STRCMP(self.keyw_read, 'DATA') EQ 1) THEN BEGIN
            value = LONARR(1)
            READU, self.pipe, value
            width = value[0]

            READU, self.pipe, value
            height = value[0]

            line = DBLARR(width)

            for i=0L, (height - 1) DO BEGIN
               READU, self.pipe, line
               (*self.rec)[*,i] = line
            ENDFOR
         ENDIF
         self.data_number = self.nIter + 1
         IF(NOT finish) THEN BEGIN
            IF(self->read_tag() NE 0) THEN BEGIN
               finish = 1
               error = 1
            ENDIF               
         ENDIF
      ENDWHILE
   ENDELSE

   IF( error EQ 1) THEN BEGIN
      IO_FAILED:
      PRINT, 'I/O failed in ExecuteStep loop with count = ', self.iIter
      self.breakFlag = 1
      RETURN, -1
   ENDIF

   IF (self.error_received EQ 1) THEN BEGIN
      PRINT, ' ERROR in C- Program, stop executing'
      self.breakFlag = 1
      RETURN, -1
   ENDIF

   RETURN, 0
END

FUNCTION ldrsDECONV_KHHBB::string_to_long, str
   barray = (BYTE(str))
   inttag = ISHFT(LONG(barray[0]),24) + ISHFT(LONG(barray[1]),16)+ ISHFT(LONG(barray[2]),8)+ LONG(barray[3])
   RETURN, inttag
END

FUNCTION ldrsDECONV_KHHBB::send_pipe, tag, str
   inttag = 0L
   inttag = self->string_to_long(tag)
   PRINT, '######-Send string to C-#######'
   WRITEU, self.pipe, inttag
   WRITEU, self.pipe, 2L
   WRITEU, self.pipe, LONG(STRLEN(str))
   WRITEU, self.pipe, str
   RETURN, 0
END

FUNCTION ldrsDECONV_KHHBB::send_pipen, tag, len, val
   inttag = 0L
   inttag = self->string_to_long(tag)
   PRINT, '######-Send data to C-#######'
   WRITEU, self.pipe, inttag
   WRITEU, self.pipe, 0L
   WRITEU, self.pipe, LONG(len)
   WRITEU, self.pipe, val
   RETURN, 0
END

FUNCTION ldrsDECONV_KHHBB::read_tag
   ON_IOERROR, IO_FAILED

   ;Read the keyword
   tagarr = BYTARR(4)
   READU, self.pipe, tagarr
   self.keyw_read = STRING(tagarr)

   ;Read the it_number
   value = LONARR(1)
   READU, self.pipe, value
   self.data_number = value[0]

   ;Read the length
   READU, self.pipe, value
   self.pipe_pack_length = value[0]

   PRINT, 'C:> -', self.keyw_read, '-', self.data_number , self.pipe_pack_length
   RETURN, 0

   IO_FAILED:
      PRINT, 'I/O failed in read tag = '
      RETURN, 1

END

FUNCTION ldrsDECONV_KHHBB::wait_tag, tag
   ON_IOERROR, IO_FAILED

   error = 0
   finish = 0

   IF(self->read_tag() NE 0) THEN BEGIN
      error = 1
      finish = 1
   ENDIF

   data_read = 0
   WHILE(NOT finish) DO BEGIN
      ;if the tag read is the disered stop reading the pipe
      IF(STRCMP(self.keyw_read, tag) EQ 1) THEN RETURN, 1
   
      data_read = 0

      ;if the tag is an INFO then print it out
      IF(STRCMP(self.keyw_read, 'STOP') EQ 1) THEN BEGIN
         IF(self->Process_stringdata() NE 0) THEN error = 1
         finish = 1
         data_read = 1
      ENDIF
      IF(STRCMP(self.keyw_read, 'INFO') EQ 1) THEN BEGIN
         IF(self->Process_stringdata() NE 0) THEN BEGIN
            error = 1
         ENDIF
         data_read = 1
      ENDIF
      IF(STRCMP(self.keyw_read, 'ERRO') EQ 1) THEN BEGIN
         IF(self->Process_stringdata() NE 0) THEN BEGIN
            error = 1
            finish = 1
         ENDIF
         data_read = 1
      ENDIF
      
      ;all other tags are ignored and the length bytes are read out of the pipe
      IF( data_read EQ 0) THEN BEGIN
         bytes_to_read = 0L
         bytes_to_read = self.pipe_pack_length
         buffersize = 256
         buffer = BYTARR(buffersize)
         WHILE (bytes_to_read GE buffersize) DO BEGIN
            READU, self.pipe, buffer
            bytes_to_read -= buffersize
         ENDWHILE
         buffer = BYTARR(bytes_to_read)
         READU, self.pipe, buffer         
         self.read_status = 2
      END      
      
      IF(NOT finish) THEN BEGIN
         IF(self->read_tag() NE 0) THEN BEGIN
            error = 1
            finish = 1
         ENDIF
      ENDIF      
   ENDWHILE

   IF( error EQ 1) THEN BEGIN
      IO_FAILED:
      PRINT, 'I/O failed in wait tag'
      self.breakFlag = 1
      RETURN, -1
   ENDIF
   RETURN,0
END

FUNCTION ldrsDECONV_KHHBB::Get_Opt2, popt, wopt
   ON_IOERROR, IO_FAILED
   distance_received = -1
   finish = 0
   line = 0
   counter = 0
   error = 0
   WHILE (NOT finish) DO BEGIN
      ;trigger C to send the best reconstruction of single distance
      IF(self->send_pipen('GOPT', 1, LONG(wopt)) NE 0) THEN BEGIN
         error = 1
         finish = 1
      ENDIF
      result = self->wait_tag('SOPT')
      IF (result EQ 1) THEN BEGIN
         lonvalue = LONARR(1)
         dblvalue = DBLARR(1)
                  
         READU, self.pipe, lonvalue
         distance_received = lonvalue[0]
          
         READU, self.pipe, dblvalue
         distance_value = dblvalue[0]
   
         READU, self.pipe, lonvalue
         width = lonvalue[0]
   
         READU, self.pipe, lonvalue
         height = lonvalue[0]
   
         IF (counter EQ 0) THEN BEGIN
            ; allocate mem for the data
            line = DBLARR(width)
         ENDIF
   
         FOR i=0L, (height - 1) DO BEGIN
            READU, self.pipe, line
            (*self.rec)(*,i) = line
         ENDFOR
       ENDIF
       IF (result EQ -1) THEN BEGIN
         error = 1
         finish = 1
       ENDIF

       IF(distance_received EQ wopt) THEN BEGIN
          ;right distance finish loop
          finish = 1
       ENDIF
   ENDWHILE

   IF error EQ 1 THEN BEGIN
       IO_FAILED:
       PRINT, 'I/O failed KHH getopt = '
       error = 1
       RETURN, -1
   ENDIF
   (*popt) = distance_value
RETURN, 1
END

FUNCTION ldrsDECONV_KHHBB::Finish
   result = 0
   result = self->ldrsDECONVOLVE::Finish()
   opt_to_save = 0
   IF(self.primresult EQ 2) THEN BEGIN
      self->save_opt, 1, self.primdist_selected
      opt_to_save = 1
   ENDIF   
   IF(self.primresult EQ 3) THEN BEGIN
      self->save_opt, 3, 0 
      opt_to_save = 1
   ENDIF   
   IF(self.secresult EQ 1) THEN BEGIN
      self->save_opt, 2, self.secdist_selected
      opt_to_save = 1
   ENDIF   
   IF(self.secresult EQ 2) THEN BEGIN
      self->save_opt, 4, 0 
      opt_to_save = 1
   ENDIF   
   IF( opt_to_save EQ 1) THEN BEGIN
      IF (self->send_pipe('STOP', '') NE 0) THEN BEGIN
         error = 1
      ENDIF
      result = self->wait_tag('NOOP')
      IF (result EQ -1) THEN BEGIN
         error = 1
      ENDIF
   END
   FREE_LUN, self.pipe
   RETURN, 1
END

PRO ldrsDECONV_KHHBB::save_opt, restype, dist
   PRINT, 'In save opt'
   result = 0
   error = 0
   finish = 0
   num_distances = N_ELEMENTS(*self.distance_names)
   distcount = 0
   optval = 0;
   poptval = PTR_NEW(optval)
   poptrecCube = PTR_NEW()
   poptimgCube = PTR_NEW()
   ;normal (one primary ext) case use the recCube and the imgCube
   poptrecCube = self.recCube
   poptimgCube = self.imgCube
   IF (restype EQ 4) THEN BEGIN
     ;alloc memory for the extension, the normal cubes can be smaller or
     ;bigger so we need temp ones
     optrecCube = DBLARR(self.nx, self.ny, num_distances)
     optimgCube = DBLARR(self.nx, self.ny, num_distances)
     poptrecCube = PTR_NEW(optrecCube)
     poptimgCube = PTR_NEW(optimgCube)
   ENDIF

   which_distance = dist

   ;create_minimale header
   recfitsheader = 0
   imgfitsheader = 0
    
   CASE restype OF
      1: BEGIN
         ;single image in primary HDU
         MKHDR, recfitsheader, *self.rec
         MKHDR, imgfitsheader, *self.img
         END
      2: BEGIN
         ;single image in image extension
         MKHDR, recfitsheader, *self.rec, /IMAGE
         MKHDR, imgfitsheader, *self.img, /IMAGE
         END
      3: BEGIN
         ;image cube in primary HDU
         MKHDR, recfitsheader, *poptrecCube
         MKHDR, imgfitsheader, *poptimgCube
         END
      4: BEGIN
         ;image cube in image extension
         MKHDR, recfitsheader, *poptrecCube, /IMAGE
         MKHDR, imgfitsheader, *poptimgCube, /IMAGE
         END
   ENDCASE

   WHILE (NOT finish) DO BEGIN
      result = self->Get_Opt2(poptval, which_distance)
      IF(NOT result EQ 0) THEN BEGIN
         PRINT, 'ERROR getting optvalue nr ', which_distance
         error = 1
         BREAK
      ENDIF      
      distselstr = STRCOMPRESS(STRING(distcount), /REMOVE_ALL)
      helpstring = "DIST"+distselstr
      SXADDPAR, recfitsheader, helpstring, (*self.distance_names)[which_distance]
      SXADDPAR, imgfitsheader, helpstring, (*self.distance_names)[which_distance]
      helpstring = "DVAL"+distselstr
      SXADDPAR, recfitsheader, helpstring, *poptval
      SXADDPAR, imgfitsheader, helpstring, *poptval

      result = self->create_img(self.rec, self.img)    
      IF(result EQ 1) THEN BEGIN
         error = 1
         BREAK
      ENDIF
      IF (restype EQ 3 OR restype EQ 4) THEN  BEGIN
         (*poptrecCube)[*,*,which_distance] = (*self.rec)[*,*]
         (*poptimgCube)[*,*,which_distance] = (*self.img)[*,*]
         which_distance++
      ENDIF
      distcount++
      IF (restype EQ 1 OR restype EQ 2 OR which_distance EQ num_distances) THEN BEGIN
         finish = 1
      ENDIF
   ENDWHILE
      
   IF(NOT error) THEN BEGIN
   ;everthing done, save the rec and img images and cubes to the files
      IF(restype EQ 1 OR restype EQ 3) THEN BEGIN
         PRINT, 'only one primary header'
         ;normal case save data in primary HDU
         result = self.recFile->StoreDataHeader(recfitsheader)
         result = self.imgFile->StoreDataHeader(imgfitsheader)      
      ENDIF ELSE BEGIN
         PRINT, 'Extension save'
         SXADDPAR, recfitsheader, "EXTNAME", "OPT"
         SXADDPAR, imgfitsheader, "EXTNAME", "OPT"
         IF(restype EQ 4) THEN BEGIN
            result = self.recFile->AppendData(recfitsheader, poptrecCube)
            result = self.imgFile->AppendData(imgfitsheader, poptimgCube)
         ENDIF
         IF(restype EQ 2) THEN BEGIN
            result = self.recFile->AppendData(recfitsheader, self.rec)
            result = self.imgFile->AppendData(imgfitsheader, self.img)
         ENDIF         
      ENDELSE
   ENDIF
   IF(restype EQ 4) THEN BEGIN
      PTR_FREE, poptrecCube
      PTR_FREE, poptimgCube
   ENDIF
END

FUNCTION ldrsDECONV_KHHBB::Get_distances
   RETURN, self.distance_names
END

PRO ldrsDECONV_KHHBB::Load, cfg
self->ldrsBUILDINGBLOCK::Load, cfg
IF OBJ_VALID(cfg) THEN BEGIN
    self.filltype = cfg->GetInt('FILLTYPE', DEFAULT=0)
    self.regAlgo = cfg->GetInt('REG.ALGO', DEFAULT=2)
    self.lambda = cfg->GetInt('REG.LAMBDA', DEFAULT=1)
    self.snr = cfg->GetFloat('SNR', DEFAULT=20000.0)
    self.nstartblocks = cfg->GetInt('NSTARTBLOCKS', DEFAULT=1000)
    self.negbkweight = cfg->GetFloat('NEGBKWEIGHT', DEFAULT=0.6)
    self.detsigma = cfg->GetFloat('DETSIGMA', DEFAULT=10.0)

    self.betaMP = cfg->GetString('REG.BETA', DEFAULT='1.0')
    self.potweightMP = cfg->GetString('POTWEIGHT', DEFAULT='0.0') 
    self.cliplevelMP = cfg->GetString('CLIPLEVEL', DEFAULT='1.0')
    
    self.blockSizeMP = cfg->GetString('BLOCKSIZE', DEFAULT='0.4')
    self.maskSizeMP = cfg->GetString('MASKSIZE', DEFAULT='100.0')
ENDIF ELSE BEGIN
    self.filltype =0
    self.regAlgo = 2
    self.lambda = 1.0
    self.snr = 20000.0
    self.nstartblocks = 1000
    self.negbkweight = 0.6
    self.detsigma = 10.0

    self.betaMP = '1.0'
    self.potweightMP = '0.0' 
    self.cliplevelMP = '1.0'

    self.blockSizeMP = '0.4'
    self.maskSizeMP = '100.0'
ENDELSE
END

PRO ldrsDECONV_KHHBB::Store, cfg
self->ldrsBUILDINGBLOCK::Store, cfg
IF OBJ_VALID(cfg) THEN BEGIN
    cfg->SetInt, 'FILLTYPE' , self.filltype
    cfg->SetInt, 'REG.ALGO', self.regAlgo
    cfg->SetInt, 'REG.LAMBDA', self.lambda
    cfg->SetFloat, 'SNR', self.snr
    cfg->SetInt, 'NSTARTBLOCKS', self.nstartblocks
    cfg->SetFloat, 'NEGBKWEIGHT', self.negbkweight      
    cfg->SetFloat, 'DETSIGMA', self.detsigma


    cfg->SetString, 'REG.BETA', self.betaMP
    cfg->SetString, 'POTWEIGHT', self.potweightMP
    cfg->SetString, 'CLIPLEVEL', self.cliplevelMP

    cfg->SetString, 'BLOCKSIZE', self.blockSizeMP
    cfg->SetString, 'MASKSIZE', self.maskSizeMP
ENDIF
END

; the number of parameters which can have multiple values which are
; used successively
FUNCTION ldrsDECONV_KHHBB::GetNoMP
RETURN, 5 + self->ldrsBUILDINGBLOCK::GetNoMP()
END

; short tag which is used as a prefix in the generated file name
FUNCTION ldrsDECONV_KHHBB::GetMPTag, nr
si = self->ldrsBUILDINGBLOCK::GetNoMP()
IF nr EQ si+0 THEN RETURN, 'b'
IF nr EQ si+1 THEN RETURN, 's'
IF nr EQ si+2 THEN RETURN, 'm'
IF nr EQ si+3 THEN RETURN, 'w'
IF nr EQ si+4 THEN RETURN, 'k'
RETURN, self->ldrsBUILDINGBLOCK::GetMPTag(nr)
END

; label whch is used in the user interface
FUNCTION ldrsDECONV_KHHBB::GetMPLabel, nr
si = self->ldrsBUILDINGBLOCK::GetNoMP()
IF nr EQ si+0 THEN RETURN, 'beta'
IF nr EQ si+1 THEN RETURN, 'blocksize'
IF nr EQ si+2 THEN RETURN, 'masksize'
IF nr EQ si+2 THEN RETURN, 'potweight'
IF nr EQ si+2 THEN RETURN, 'cliplevel'
RETURN, self->ldrsBUILDINGBLOCK::GetMPLabel(nr)
END

; get a string which contains all values of a specific parameter
FUNCTION ldrsDECONV_KHHBB::GetMPValues, nr
si = self->ldrsBUILDINGBLOCK::GetNoMP()
IF nr EQ si+0 THEN RETURN, self.betaMP
IF nr EQ si+1 THEN RETURN, self.blockSizeMP
IF nr EQ si+2 THEN RETURN, self.maskSizeMP
IF nr EQ si+3 THEN RETURN, self.potweightMP
IF nr EQ si+4 THEN RETURN, self.cliplevelMP
RETURN, self->ldrsBUILDINGBLOCK::GetMPValues(nr)
END

; set a parameter to a specific value which is givan as a string
PRO ldrsDECONV_KHHBB::SetMP, nr, val
si = self->ldrsBUILDINGBLOCK::GetNoMP()
IF nr LT si THEN self->ldrsBUILDINGBLOCK::SetMP, nr, val
IF nr EQ si+0 THEN self.beta = FLOAT(val)
IF nr EQ si+1 THEN self.blockSize = FLOAT(val)
IF nr EQ si+2 THEN self.maskSize = FLOAT(val)
IF nr EQ si+3 THEN self.potweight = FLOAT(val)
IF nr EQ si+4 THEN self.cliplevel = FLOAT(val)
END

PRO ldrsDECONV_KHHBB::ItemSelected, id, item
self->ldrsBUILDINGBLOCK::ItemSelected, id, item
IF id EQ self.dFilltype THEN self.filltype = item
IF id EQ self.dRegAlgo THEN self.regAlgo = item
END

PRO ldrsDECONV_KHHBB::ReadDynamicContent
self->ldrsBUILDINGBLOCK::ReadDynamicContent
WIDGET_CONTROL, self.dFilltype, SET_COMBOBOX_SELECT=self.filltype
WIDGET_CONTROL, self.dRegAlgo, SET_COMBOBOX_SELECT=self.regAlgo
;WIDGET_CONTROL, self.dLambda, SET_VALUE=STRING(self.lambda)
WIDGET_CONTROL, self.dSNR, SET_VALUE=STRING(self.snr)
WIDGET_CONTROL, self.dstartblocks, SET_VALUE=STRING(self.nstartblocks)
WIDGET_CONTROL, self.dNegbkWeight, SET_VALUE=STRING(self.negbkweight)
WIDGET_CONTROL, self.dDetSigma, SET_VALUE=STRING(self.detsigma)

WIDGET_CONTROL, self.dBeta, SET_VALUE=self.betaMP
WIDGET_CONTROL, self.dBlockSize, SET_VALUE=self.blockSizeMP
WIDGET_CONTROL, self.dMaskSize, SET_VALUE=self.maskSizeMP
WIDGET_CONTROL, self.dPotWeight, SET_VALUE=self.potweightMP
WIDGET_CONTROL, self.dClipLevel, SET_VALUE=self.cliplevelMP
END

PRO ldrsDECONV_KHHBB::WriteDynamicContent
self->ldrsBUILDINGBLOCK::WriteDynamicContent
;WIDGET_CONTROL, self.dLambda, GET_VALUE=str
;self.lambda = FLOAT(str)
WIDGET_CONTROL, self.dSNR, GET_VALUE=str
self.snr = FLOAT(str)
WIDGET_CONTROL, self.dStartblocks, GET_VALUE=str
self.nstartblocks = FIX(str)
WIDGET_CONTROL, self.dNegbkWeight, GET_VALUE=str
self.negbkweight = FLOAT(str)
WIDGET_CONTROL, self.dDetSigma, GET_VALUE=str
self.detsigma = FLOAT(str)


WIDGET_CONTROL, self.dBeta, GET_VALUE=str
self.betaMP = str
WIDGET_CONTROL, self.dBlockSize, GET_VALUE=str
self.blockSizeMP = str
WIDGET_CONTROL, self.dMaskSize, GET_VALUE=str
self.maskSizeMP = str
WIDGET_CONTROL, self.dPotWeight, GET_VALUE=str
self.potweightMP = str
WIDGET_CONTROL, self.dClipLevel, GET_VALUE=str
self.cliplevelMP = str
END

PRO ldrsDECONV_KHHBB::CreateContent
self->ldrsBUILDINGBLOCK::CreateContent
row = self->GetFreeRow()
lab             = self->CreateLabel(0, row, 'Fill type', /HALIGN_RIGHT)
self.dFilltype  = self->CreateComboBox(2, row, ['All', 'Extrema'])
row++
lab               = self->CreateLabel(0, row, 'Regularization:', /HALIGN_RIGHT)
;lab              = self->CreateLabel(1, row, 'Algo', /HALIGN_RIGHT)
self.dRegAlgo     = self->CreateComboBox(2, row, ['None', 'Sum{|ok|^2}', 'Sum{ok*ln|ok|}', 'Sum{ln|ok|}'])
;lab              = self->CreateLabel(0, row, 'Lambda:')
;self.dLambda     = self->CreateEntry(2, row, VALUE='1.0')
;row++
lab               = self->CreateLabel(3, row, 'Beta:', /HALIGN_RIGHT)
self.dBeta        = self->CreateEntry(4, row, VALUE='1.0')
row++
lab               = self->CreateLabel(0, row, 'Detector sigma noise:', /HALIGN_RIGHT)
self.dDetSigma    = self->CreateEntry(2, row, VALUE='10.0')
lab               = self->CreateLabel(3, row, 'SNR:', /HALIGN_RIGHT)
self.dSNR         = self->CreateEntry(4, row, VALUE='20000.0')
row++
lab               = self->CreateLabel(0, row, 'Blocksize:', /HALIGN_RIGHT)
self.dBlockSize   = self->CreateEntry(2, row, VALUE='20000.0')
row++
lab               = self->CreateLabel(0, row, 'Masksize[%]:', /HALIGN_RIGHT)
self.dMaskSize    = self->CreateEntry(2, row, VALUE='100.0')
row++
lab               = self->CreateLabel(0, row, '1/Var weight exponent:', /HALIGN_RIGHT)
self.dPotWeight   = self->CreateEntry(2, row, VALUE='0.0')
row++
lab               = self->CreateLabel(0, row, 'Clip leve[%]:', /HALIGN_RIGHT)
self.dClipLevel   = self->CreateEntry(2, row, VALUE='1.0')
row++
lab               = self->CreateLabel(0, row, '#Start blocks:', /HALIGN_RIGHT)
self.dStartblocks = self->CreateEntry(2, row, VALUE='1000')
row++
lab               = self->CreateLabel(0, row, 'Neg blocks weight:', /HALIGN_RIGHT)
self.dNegbkWeight   = self->CreateEntry(2, row, VALUE='0.6')
row++
END

PRO ldrsDECONV_KHHBB__define
struct = { ldrsDECONV_KHHBB, $
           INHERITS ldrsBUILDINGBLOCK, $
           tuefradius:0, $
           dFilltype:0, filltype:0, $
           dRegAlgo:0, regAlgo:0, $
           dLambda:0, lambda:1, $
           dBeta:0, betaMP:'', beta:1.0, $
           dSNR:0, snr:0.0, $
           dStartBlocks:0, nstartblocks:1000, $
           dNegbkWeight:0, negbkweight:0.6, $
           dBlockSize:0, blockSizeMP:'', blockSize:0.4, $
           dMaskSize:0, maskSizeMP:'', maskSize:100.0, $
           dPotWeight:0, potweightMP:'', potweight:0.0, $
           dClipLevel:0, cliplevelMP:'', cliplevel:0.0, $
           dDetSigma:0, detsigma:10.0, $
           pipe:0, $
           error_received:0, $
           data_number:0, $
           keyw_read:'', $
           read_status:0, $
           pipe_pack_length:0L, $
           distance_names:PTR_NEW(), $
           cmd_Line:'' $
         }
END
