PRO LDRS_DIALOG_KILL, top
END

PRO LDRS_DIALOG_APPLY, Event
PRINT, 'LDRS_DIALOG_APPLY:', Event
WIDGET_CONTROL, event.id, GET_UVALUE=obj
IF NOT OBJ_VALID(obj) THEN RETURN
IF OBJ_ISA(obj, 'ldrsDIALOG') THEN obj->DoApply
END

PRO LDRS_DIALOG_CLOSE, Event
PRINT, 'LDRS_DIALOG_CLOSE:', Event
WIDGET_CONTROL, event.id, GET_UVALUE=obj
IF NOT OBJ_VALID(obj) THEN RETURN
IF OBJ_ISA(obj, 'ldrsDIALOG') THEN obj->DoClose
END

PRO LDRS_DIALOG_UPDATE, Event
PRINT, 'LDRS_DIALOG_UPDATE:', Event
WIDGET_CONTROL, event.id, GET_UVALUE=obj
IF NOT OBJ_VALID(obj) THEN RETURN
IF OBJ_ISA(obj, 'ldrsDIALOG') THEN obj->DoUpdate
END

PRO LDRS_DIALOG_RECENTER, Event
PRINT, 'LDRS_DIALOG_RECENTER:', Event
WIDGET_CONTROL, event.id, GET_UVALUE=obj
IF NOT OBJ_VALID(obj) THEN RETURN
IF OBJ_ISA(obj, 'ldrsDIALOG') THEN obj->DoRecenter
END

PRO LDRS_DIALOG_LIST_EVENT, event
;PRINT, 'LDRS_DIALOG_LIST_EVENT:', Event
WIDGET_CONTROL, event.id, GET_UVALUE=cbs, /NO_COPY
dest = cbs.dest
name = cbs.name
WIDGET_CONTROL, event.id, SET_UVALUE=cbs, /NO_COPY
IF NOT OBJ_VALID(dest) THEN RETURN
IF OBJ_ISA(dest, 'ldrsDIALOG') THEN CALL_METHOD, name, dest, event.id, event.index
END

PRO LDRS_DIALOG_BUTTON_EVENT, event
;PRINT, 'LDRS_DIALOG_BUTTON_EVENT:', Event
WIDGET_CONTROL, event.id, GET_UVALUE=obj
IF NOT OBJ_VALID(obj) THEN RETURN
IF OBJ_ISA(obj, 'ldrsDIALOG') THEN obj->ButtonPressed, event.id
END

FUNCTION ldrsDIALOG::Init
self.dlgTitle = 'LDRS Dialog'
self.optionsLoaded = 0
RETURN, 1
END

PRO ldrsDIALOG::Load, cfg
self.optionsLoaded = 1
END

PRO ldrsDIALOG::Store, cfg
END

PRO ldrsDIALOG::ReadStaticContent
END

PRO ldrsDIALOG::WriteStaticContent
END

PRO ldrsDIALOG::ReadDynamicContent
END

PRO ldrsDIALOG::WriteDynamicContent
END

PRO ldrsDIALOG::ShowDialog
IF self.dlgBase NE 0 THEN WIDGET_CONTROL, self.dlgBase, MAP=1
self.dlgVisible = 1
END

PRO ldrsDIALOG::HideDialog
IF self.dlgBase NE 0 THEN WIDGET_CONTROL, self.dlgBase, MAP=0
self.dlgVisible = 0
END

PRO ldrsDIALOG::DoApply
self->WriteStaticContent
self->WriteDynamicContent
self->Store
END

PRO ldrsDIALOG::DoClose
self->HideDialog
END

PRO ldrsDIALOG::DoUpdate
END

PRO ldrsDIALOG::DoRecenter
END

PRO ldrsDIALOG::AddElement, el, x, y, NX=nx, NY=ny, $
              VALIGN_TOP=top, VALIGN_BOTTOM=bottom, VALIGN_CENTER=vcenter, $
              HALIGN_LEFT=left, HALIGN_RIGHT=right, HALIGN_CENTER=hcenter
; set default values
IF N_ELEMENTS(nx) EQ 0 THEN nx = 1
IF N_ELEMENTS(ny) EQ 0 THEN ny = 1
halign = 3
IF N_ELEMENTS(hcenter) THEN halign = 0
IF N_ELEMENTS(left) THEN halign = 1
IF N_ELEMENTS(right) THEN halign = 2
valign = 3
IF N_ELEMENTS(vcenter) THEN valign = 0
IF N_ELEMENTS(top) THEN valign = 1
IF N_ELEMENTS(bottom) THEN valign = 2
self.dlgElements[self.dlgNElements, 0] = el
self.dlgElements[self.dlgNElements, 1] = x
self.dlgElements[self.dlgNElements, 2] = y
self.dlgElements[self.dlgNElements, 3] = nx
self.dlgElements[self.dlgNElements, 4] = ny
self.dlgElements[self.dlgNElements, 7] = halign*4 + valign
self.dlgNElements++
END

FUNCTION ldrsDIALOG::CreateLabel, x, y, title, _REF_EXTRA=ex
el = WIDGET_LABEL(self.dlgContent, VALUE=title)
self->AddElement, el, x, y, _EXTRA=ex
RETURN, el
END

FUNCTION ldrsDIALOG::CreateEntry, x, y, VALUE=value, XSIZE=xsize, _REF_EXTRA=ex
IF N_ELEMENTS(value) EQ 0 THEN value = ''
IF N_ELEMENTS(xsize) EQ 0 THEN xsize = 16
el = WIDGET_TEXT(self.dlgContent, /EDITABLE, VALUE=value, XSIZE=xsize)
self->AddElement, el, x, y, _EXTRA=ex
RETURN, el
END

PRO ldrsDIALOG::ItemSelected, id, item
END

FUNCTION ldrsDIALOG::CreateList, x, y, EVENT_PRO=event_pro, YSIZE=ysize, _REF_EXTRA=ex
IF N_ELEMENTS(ysize) EQ 0 THEN ysize = 5
IF N_ELEMENTS(event_pro) EQ 0 THEN event_pro = 'LDRS_DIALOG_LIST_EVENT'
el = WIDGET_LIST(self.dlgContent, YSIZE=ysize, EVENT_PRO=event_pro, $
                 UVALUE={dest:self, name:'ItemSelected'})
self->AddElement, el, x, y, _EXTRA=ex
RETURN, el
END

PRO ldrsDIALOG::ButtonPressed, id
END

FUNCTION ldrsDIALOG::CreateButton, x, y, title, EVENT_PRO=event_pro, _REF_EXTRA=ex
IF N_ELEMENTS(event_pro) EQ 0 THEN event_pro = 'LDRS_DIALOG_BUTTON_EVENT'
el = WIDGET_BUTTON(self.dlgContent, VALUE=title, EVENT_PRO=event_pro, /SENSITIVE, UVALUE=self)
self->AddElement, el, x, y, _EXTRA=ex
RETURN, el
END

FUNCTION ldrsDIALOG::CreateComboBox, x, y, value, EVENT_PRO=event_pro, _REF_EXTRA=ex
IF N_ELEMENTS(event_pro) EQ 0 THEN event_pro = 'LDRS_DIALOG_LIST_EVENT'
el = WIDGET_COMBOBOX(self.dlgContent, EVENT_PRO=event_pro, /SENSITIVE, VALUE=value, $
                     UVALUE={dest:self, name:'ItemSelected'})
self->AddElement, el, x, y, _EXTRA=ex
RETURN, el
END

FUNCTION ldrsDIALOG::CreateProcedureMenu, x, y, tag, set_method, _REF_EXTRA=ex
COMMON ldrs, env
; find the configuration entry for the procedure group named <tag>
cfg = env.config->LocateByName('PGROUP', /NO_CREATE)
IF NOT OBJ_VALID(cfg) THEN RETURN, 0
cfg = cfg->GetFirst()
WHILE OBJ_VALID(cfg) DO BEGIN
    hcfg = cfg->LocateByName('TAG', /NO_CREATE)
    IF NOT OBJ_VALID(hcfg) THEN BEGIN
        ; no tag value (malformed?), continue with the next entry
        PRINT, 'ldrsDIALOG::CreateProcedureMenu, PGROUP with nr ', cfg->GetNr(), ' has no tag field, malformed?'
        cfg = cfg->GetNext()
        CONTINUE
    ENDIF
    htag = hcfg->GetString('')
    IF htag NE tag THEN BEGIN
        ; not the required tag, continue with the next entry
        cfg = cfg->GetNext()
        CONTINUE
    ENDIF
    ; we found the procedure group named <tag>
    hcfg = cfg->LocateByName('PROC', /NO_CREATE)
    IF NOT OBJ_VALID(hcfg) THEN BEGIN
        ; no tag value (malformed?), continue with the next entry
        PRINT, 'ldrsDIALOG::CreateProcedureMenu, PGROUP with tag ', tag, ' has no associated procedures, malformed?'
        cfg = cfg->GetNext()
        CONTINUE
    ENDIF
    ; we found the PROC list
    nChilds = hcfg->GetNChilds()
    list = STRARR(nChilds)
    hhcfg = hcfg->GetFirst()
    nr = 0
    WHILE OBJ_VALID(hhcfg) DO BEGIN
        hhhcfg = hhcfg->LocateByName('LABEL', /NO_CREATE)
        IF NOT OBJ_VALID(hhhcfg) THEN BEGIN
            list[nr++] = '?No Label?'
            hhcfg = hhcfg->GetNext()
        ENDIF
        list[nr++] = hhhcfg->GetString('', DEFAULT='?No Label?')
        hhcfg = hhcfg->GetNext()
    ENDWHILE
    el = WIDGET_COMBOBOX(self.dlgContent, $
                         EVENT_PRO='LDRS_DIALOG_LIST_EVENT', $
                         /SENSITIVE, $
                         VALUE=list, $
                         UVALUE={dest:self, name:set_method})
    self->AddElement, el, x, y, _EXTRA=ex
    RETURN, el
ENDWHILE
; no procedure found
PRINT, 'ldrsDIALOG::CreateProcedureMenu, no PGROUP with tag ', tag, $
  ', and PROCEDURE with nr ', nr, $
  ' found, incomplete config file!'
RETURN, 0
END

FUNCTION ldrsDIALOG::CreateCheckbox, x, y, title, _REF_EXTRA=ex
el = CW_BGROUP(self.dlgContent, [title], /NONEXCLUSIVE)
self->AddElement, el, x, y, _EXTRA=ex
RETURN, el
END

FUNCTION ldrsDIALOG::GetFreeRow
IF self.dlgNElements EQ 0 THEN RETURN, 0
RETURN, MAX(self.dlgElements[0:self.dlgNElements-1,2] + self.dlgElements[0:self.dlgNElements-1,4])
END

PRO ldrsDIALOG::DoLayout
; get the geometry for all widgets
FOR i=0,self.dlgNElements-1 DO BEGIN
    geo = WIDGET_INFO(self.dlgElements[i, 0], /GEOMETRY)
    self.dlgElements[i, 5] = geo.scr_xsize
    self.dlgElements[i, 6] = geo.scr_ysize
ENDFOR
; calculate the number of rows and columns
nx = MAX(self.dlgElements[*,1] + self.dlgElements[*,3])
ny = MAX(self.dlgElements[*,2] + self.dlgElements[*,4])
;PRINT, '  nx=', nx, ', ny=', ny
; calculate the size of all columns and rows
colWidths  = LONARR(nx)
colLeft    = LONARR(nx)
rowHeights = LONARR(ny)
rowTop     = LONARR(ny)
; loop over all columnspans in increasing order and distribute the
; required width of all widgets
maxNX = MAX(self.dlgElements[*,3])
;PRINT, '  maxNX=', maxNX
FOR cs=1,maxNX DO BEGIN
    FOR i=0,self.dlgNElements-1 DO BEGIN
        x = self.dlgElements[i, 1]
        ; skip all widgets which do not need cs columns
        IF self.dlgElements[i, 3] NE cs THEN CONTINUE
        ;PRINT, '    widget ', self.dlgElements[i, 0], ' at ', x
        ; calculate the already available space
        avail = TOTAL(colWidths[x:x+cs-1])
        ;PRINT, '      avail=', avail
        IF avail GE self.dlgElements[i, 5] THEN CONTINUE ; there is enough space
        ; calculate the additional space for each column and distribute it
        delta = ceil((self.dlgElements[i, 5] - avail)/cs)
        ;PRINT, '     delta =', delta
        colWidths[x:x+cs-1] += delta
    ENDFOR
ENDFOR
FOR x=1,nx-1 DO colLeft[x] = colLeft[x-1]+colWidths[x-1]
; loop over all rowspans in increasing order and distribute the
; required height of all widgets
maxNY = MAX(self.dlgElements[*,4])
FOR rs=1,maxNY DO BEGIN
    FOR i=0,self.dlgNElements-1 DO BEGIN
        y = self.dlgElements[i, 2]
        ; skip all widgets which do not need rs rows
        IF self.dlgElements[i, 4] NE rs THEN CONTINUE
        ; calculate the already available space
        avail = TOTAL(rowHeights[y:y+rs-1])
        IF avail GE self.dlgElements[i, 6] THEN CONTINUE ; there is enough space
        ; calculate the additional space for each row and distribute it
        delta = ceil((self.dlgElements[i, 6] - avail)/rs)
        rowHeights[y:y+rs-1] += delta
    ENDFOR
ENDFOR
FOR y=1,ny-1 DO rowTop[y] = rowTop[y-1]+rowHeights[y-1]
;PRINT, ' column widths', colWidths
;PRINT, ' row heights', rowHeights
; set the position and size according to the layout
WIDGET_CONTROL, self.dlgContent, UPDATE=0
FOR i=0,self.dlgNElements-1 DO BEGIN
    w = self.dlgElements[i, 0]
    x = self.dlgElements[i, 1]
    y = self.dlgElements[i, 2]
    xsize = self.dlgElements[i, 5]
    ysize = self.dlgElements[i, 6]
    cs = self.dlgElements[i, 3]
    rs = self.dlgElements[i, 4]
    xavail = TOTAL(colWidths[x:x+cs-1])
    yavail = TOTAL(rowHeights[y:y+rs-1])
    ; modify the horizontal dimensions
    halign = self.dlgElements[i, 7]/4
    CASE halign OF
        0: WIDGET_CONTROL, w, XOFFSET=colLeft[x]+(xavail-xsize)/2
        1: WIDGET_CONTROL, w, XOFFSET=colLeft[x]
        2: WIDGET_CONTROL, w, XOFFSET=colLeft[x]+xavail-xsize
        3: WIDGET_CONTROL, w, XOFFSET=colLeft[x], SCR_XSIZE=xavail
    ENDCASE
    ; modify the vertical dimensions
    valign = self.dlgElements[i, 7] MOD 4
    CASE valign OF
        0: WIDGET_CONTROL, w, YOFFSET=rowTop[y]+(yavail-ysize)/2
        1: WIDGET_CONTROL, w, YOFFSET=rowTop[y]
        2: WIDGET_CONTROL, w, YOFFSET=rowTop[y]+yavail-ysize
        3: WIDGET_CONTROL, w, YOFFSET=rowTop[y], SCR_YSIZE=yavail
    ENDCASE
ENDFOR
WIDGET_CONTROL, self.dlgContent, UPDATE=1
END

PRO ldrsDIALOG::CreateContent
self.dlgContent = WIDGET_BASE(self.dlgBase)
END

PRO ldrsDIALOG::CreateButtons
self.dlgButtons = WIDGET_BASE(self.dlgBase, /ROW, /FRAME)
self.dlgApplyButton = WIDGET_BUTTON(self.dlgButtons, VALUE='Apply', EVENT_PRO='LDRS_DIALOG_APPLY', UVALUE=self)
self.dlgCloseButton = WIDGET_BUTTON(self.dlgButtons, VALUE='Close', EVENT_PRO='LDRS_DIALOG_CLOSE', UVALUE=self)
END

PRO ldrsDIALOG::CreateDialog, top
IF self.dlgBase NE 0 THEN RETURN
PRINT, 'ldrsDIALOG::CreateDialog, ', top
self.dlgBase = WIDGET_BASE(/COLUMN, TITLE=self.dlgTitle, GROUP_LEADER=top, $
                           KILL_NOTIFY='LDRS_DIALOG_KILL')
IF self.dlgBase EQ 0 THEN RETURN
self->CreateContent
self->CreateButtons
WIDGET_CONTROL, self.dlgBase, /REALIZE
self->DoLayout
XMANAGER, 'LDRS_GUI', self.dlgBase, /JUST_REG, /NO_BLOCK
END


; dlgElements = LONARR(100, 7)
; dlgElements[*,0] : widget id
; dlgElements[*,1] : x (column)
; dlgElements[*,2] : y (row)
; dlgElements[*,3] : nx (columnspan)
; dlgElements[*,4] : ny (rowspan)
; dlgElements[*,5] : scr_xsize (from widget_info(id, /geometry))
; dlgElements[*,6] : scr_ysize (from widget_info(id, /geometry))
; dlgElements[*,7] : align:
;                    VALIGN_TOP, VALIGN_BOTTOM, VALIGN_CENTER,
;                    VALIGN_FILL (default)
;                    HALIGN_LEFT, HALIGN_RIGHT, HALIGN_CENTER,
;                    HALIGN_FILL (default)
PRO ldrsDIALOG__define
struct = { ldrsDIALOG, $
           dlgTitle:'', $
           dlgBase:0, $
           dlgContent:0, $
           dlgButtons:0, $
           dlgApplyButton:0, $
           dlgCloseButton:0, $
           dlgNElements:0, $
           dlgElements:LONARR(100, 8), $
           dlgVisible:0, $
           optionsLoaded:0 $
         }
END
