PRO LDRS_FLOWCHART_EVENT, event
COMMON ldrs, env
;PRINT, 'LDRS_CHART_EVENT: type=', event.type, ', release=', event.release
IF (event.type NE 1) THEN RETURN
WIDGET_CONTROL, event.ID, GET_UVALUE=fc
IF (event.release EQ 1) THEN fc->MouseLeftRelease, event
IF (event.release EQ 2) THEN fc->MouseMiddleRelease, event
IF (event.release EQ 4) THEN fc->MouseRightRelease, event
END

FUNCTION ldrsFLOWCHART::Init, cfg, frame
IF NOT self->ldrsVIEW::Init(cfg, frame) THEN RETURN, 0

RETURN, 1
END

FUNCTION ldrsFLOWCHART::FindNodePolygon, node
;PRINT, 'ldrsFLOWCHART::FindNodePolygon, ', node
polys = self.fcGraph->Get(/ALL, ISA='IDLgrPolygon')
FOR i=0, N_ELEMENTS(polys) - 1 DO BEGIN
    polys[i]->GetProperty, UVALUE=hnode
    IF NOT OBJ_VALID(hnode) THEN CONTINUE
    ;PRINT, '  comparing ', node, ' with ', hnode
    IF hnode EQ node THEN RETURN, polys[i]
END
RETURN, OBJ_NEW()
END

FUNCTION ldrsFLOWCHART::FindNodePolyline, node
;PRINT, 'ldrsFLOWCHART::FindNodePolygon, ', node
polys = self.fcGraph->Get(/ALL, ISA='IDLgrPolyline')
FOR i=0, N_ELEMENTS(polys) - 1 DO BEGIN
    polys[i]->GetProperty, UVALUE=hnode
    IF NOT OBJ_VALID(hnode) THEN CONTINUE
    ;PRINT, '  comparing ', node, ' with ', hnode
    IF hnode EQ node THEN RETURN, polys[i]
END
RETURN, OBJ_NEW()
END

PRO ldrsFLOWCHART::ModuleSelected, module
;PRINT, 'ldrsFLOWCHART::ModuleSelected, ', module->GetLabel()
poly = self->FindNodePolygon(module)
IF NOT OBJ_VALID(poly) THEN RETURN
poly->SetProperty, COLOR=[255, 0, 255]
self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::ModuleDeselected, module
;PRINT, 'ldrsFLOWCHART::ModuleDeselected, ', module->GetLabel()
poly = self->FindNodePolygon(module)
IF NOT OBJ_VALID(poly) THEN RETURN
poly->SetProperty, COLOR=module->GetColor()
self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::ModuleUnused, module
;PRINT, 'ldrsFLOWCHART::ModuleSelected, ', module->GetLabel()
poly = self->FindNodePolyline(module)
IF NOT OBJ_VALID(poly) THEN RETURN
poly->SetProperty, POLYLINES=[2, 0, 2, 2, 1, 3]
;COLOR=[255, 0, 0]
self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::ModuleUsed, module
;PRINT, 'ldrsFLOWCHART::ModuleDeselected, ', module->GetLabel()
poly = self->FindNodePolyline(module)
IF NOT OBJ_VALID(poly) THEN RETURN
poly->SetProperty, POLYLINES=[0]
;COLOR=module->GetColor()
self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::FiletypeSelected, filetype
poly = self->FindNodePolygon(filetype)
IF NOT OBJ_VALID(poly) THEN RETURN
poly->SetProperty, COLOR=[255, 0, 255]
self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::FiletypeDeselected, filetype
poly = self->FindNodePolygon(filetype)
IF NOT OBJ_VALID(poly) THEN RETURN
poly->SetProperty, COLOR=filetype->GetColor()
self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::MouseLeftRelease, event
COMMON ldrs, env
;PRINT, 'ldrsFLOWCHART::MouseRelease, mouse click detected at (', event.x, ',', event.y, ')'
selObj = self.fcWin->Select(self.fcView, [event.x, event.y])
selSpec = SIZE(selObj)
IF selSpec[0] EQ 0 THEN BEGIN
    ;PRINT, '   no object selected'
    env.recipe->DeselectModule
    env.recipe->DeselectFiletype
    RETURN
END
selObj = selObj[0]
selClass = OBJ_CLASS(selObj)
;PRINT, '   object of class ', selClass, ' found'
IF NOT OBJ_ISA(selObj, 'IDLgrPolygon') AND NOT OBJ_ISA(selObj, 'IDLgrText') THEN BEGIN
    ;PRINT, '   wrong class, IDLgrPolygon or IDLgrText expected'
    RETURN
END
selObj->GetProperty, UVALUE=selNode
nodeClass = OBJ_CLASS(selNode)
;PRINT, '   node of class ', nodeClass, ', label=', selNode->GetLabel(), ' selected'
IF OBJ_ISA(selNode, 'ldrsMODULE') THEN env.recipe->SelectModule, selNode
IF OBJ_ISA(selNode, 'ldrsFILETYPE') THEN env.recipe->SelectFiletype, selNode
END

PRO ldrsFLOWCHART::MouseMiddleRelease, event
END

PRO ldrsFLOWCHART::MouseRightRelease, event
COMMON ldrs, env
;PRINT, 'ldrsFLOWCHART::MouseRelease, mouse click detected at (', event.x, ',', event.y, ')'
selObj = self.fcWin->Select(self.fcView, [event.x, event.y])
selSpec = SIZE(selObj)
IF selSpec[0] EQ 0 THEN BEGIN
    ;PRINT, '   no object selected'
    RETURN
END
selObj = selObj[0]
selClass = OBJ_CLASS(selObj)
;PRINT, '   object of class ', selClass, ' found'
IF NOT OBJ_ISA(selObj, 'IDLgrPolygon') AND NOT OBJ_ISA(selObj, 'IDLgrText') THEN BEGIN
    ;PRINT, '   wrong class, IDLgrPolygon or IDLgrText expected'
    RETURN
END
selObj->GetProperty, UVALUE=selNode
nodeClass = OBJ_CLASS(selNode)
;PRINT, '   node of class ', nodeClass, ', label=', selNode->GetLabel(), ' selected'
IF NOT OBJ_ISA(selNode, 'ldrsMODULE') THEN RETURN
IF selNode->IsUsed() THEN BEGIN
    selNode->SetUsed, 0
    self->ModuleUnused, selNode
ENDIF ELSE BEGIN
    selNode->SetUsed, 1
    self->ModuleUsed, selNode
ENDELSE
;self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::CreateContent, cfgPanel
;PRINT, 'ldrsFLOWCHART::CreateContent called'
self.guiPanel = WIDGET_DRAW(self.guiBase, /EXPOSE_EVENTS, $
                         UNITS=0, SCR_XSIZE=self.scrSize[0], SCR_YSIZE=self.scrSize[1], $
                         GRAPHICS_LEVEL=2, RENDERER=1, $
                         BUTTON_EVENTS=1, UVALUE=self)
END

PRO ldrsFLOWCHART::CreateNode, node
nodeLabel = node->GetLabel()
nodeColor = node->GetColor()
nodeBox = node->GetBox()
x = nodeBox[0]
y = nodeBox[1]
w = nodeBox[2]
h = nodeBox[3]
bo = OBJ_NEW('IDLgrPolygon', UVALUE=node, $
             [x, x+w, x+w, x], [y, y, y+h, y+h], $
             COLOR=nodeColor)
self.fcGraph->ADD, bo
IF OBJ_ISA(node, 'ldrsMODULE') THEN BEGIN
    fo = OBJ_NEW('IDLgrPolyline', UVALUE=node, $
                 [x, x+w, x+w, x], [y, y, y+h, y+h], [0.5, 0.5, 0.5, 0.5], $
                 POLYLINES=[0], $
                 COLOR=[255, 0, 0])
    self.fcGraph->ADD, fo
ENDIF
lo = OBJ_NEW('IDLgrText', UVALUE=node, $
             nodeLabel, $
             COLOR=[0, 0, 0], ALIGNMENT=0.5, VERTICAL_ALIGNMENT=0.5, $
             LOCATIONS=[x+w/2, y+h/2, 1], $
             FONT=self.fcFont)
self.fcGraph->ADD, lo
END

PRO ldrsFLOWCHART::CreateEdge, fromNode, toNode
; calculate the straight line between the boundaries of the two nodes
box = fromNode->GetBox()
w1 = box[2]/2.0
h1 = box[3]/2.0
x1 = box[0] + w1
y1 = box[1] + h1
box = toNode->GetBox()
w2 = box[2]/2.0
h2 = box[3]/2.0
x2 = box[0] + w2
y2 = box[1] + h2
dx = x2 - x1
dy = y2 - y1
d = SQRT(dx*dx + dy*dy)
dx = dx/d
dy = dy/d
IF dx EQ 0 THEN BEGIN
    IF dy GT 0 THEN BEGIN       ; the destination node is above
        y1 = y1 + h1
        y2 = y2 - h2
    END ELSE BEGIN              ; the destination node is below
        y1 = y1 - h1
        y2 = y2 + h2
    END
END ELSE IF dy EQ 0 THEN BEGIN
    IF dx GT 0 THEN BEGIN       ; the destination node is on the right
        x1 = x1 + w1
        x2 = x2 - w2
    END ELSE BEGIN              ; the destination node is on the left
        x1 = x1 - w1
        x2 = x2 + w2
    END
END ELSE BEGIN
    IF dx GT 0 THEN BEGIN       ; the destination node is on the right
        IF dy GT 0 THEN BEGIN   ; the destination node is above
            x1h1 = w1
            y1h2 = h1
            x2h1 = -w2
            y2h2 = -h2
        END ELSE BEGIN          ; the destination node is below
            x1h1 = w1
            y1h2 = -h1
            x2h1 = -w2
            y2h2 = h2
        END
    END ELSE BEGIN              ; the destination node is on the left
        IF dy GT 0 THEN BEGIN   ; the destination node is above
            x1h1 = -w1
            y1h2 = h1
            x2h1 = w2
            y2h2 = -h2
        END ELSE BEGIN          ; the destination node is below
            x1h1 = -w1
            y1h2 = -h1
            x2h1 = w2
            y2h2 = h2
        END
    END
    y1h1 = dy*x1h1/dx
    x1h2 = dx*y1h2/dy
    y2h1 = dy*x2h1/dx
    x2h2 = dx*y2h2/dy
    IF x1h1*x1h1 + y1h1*y1h1 GT x1h2*x1h2 + y1h2*y1h2 THEN BEGIN
        x1 = x1 + x1h2
        y1 = y1 + y1h2
    END ELSE BEGIN
        x1 = x1 + x1h1
        y1 = y1 + y1h1
    END
    IF x2h1*x2h1 + y2h1*y2h1 GT x2h2*x2h2 + y2h2*y2h2 THEN BEGIN
        x2 = x2 + x2h2
        y2 = y2 + y2h2
    END ELSE BEGIN
        x2 = x2 + x2h1
        y2 = y2 + y2h1
    END
END
oCon = OBJ_NEW('IDLgrPolyline', [x1, x2], [y1, y2], COLOR=[0, 0, 0])
self.fcGraph->ADD, oCon
                                ;dx = x1 - x2
                                ;dy = y1 - y2
                                ;d = SQRT(dx*dx + dy*dy)
                                ;dx = dx/d
                                ;dy = dy/d
                                ;oArrow = OBJ_NEW('IDLgrPolyline', $
                                ;                 [x2 + 0.2*dx - 0.1*dy, x2, x2 + 0.2*dx + 0.1*dy], $
                                ;                 [y2 + 0.2*dy + 0.1*dx, y2, y2 + 0.2*dy - 0.1*dx], $
                                ;                 COLOR=col)
                                ;self->ADD, oArrow
END

PRO ldrsFLOWCHART::RealizeGUI
COMMON ldrs, env
WIDGET_CONTROL, self.guiPanel, EVENT_PRO='LDRS_FLOWCHART_EVENT'
WIDGET_CONTROL, self.guiPanel, GET_VALUE = oWindow
self.fcWin = oWindow
; create all basic flowchart objects (font, view, and graph)
self.fcFont = OBJ_NEW('IDLgrFont', SIZE=self.fontSize)
; calculate the bounding box of the diagram
boxLeft   = FLTARR(env.recipe->GetNFiletypes() + env.recipe->GetNModules())
boxRight  = FLTARR(env.recipe->GetNFiletypes() + env.recipe->GetNModules())
boxBottom = FLTARR(env.recipe->GetNFiletypes() + env.recipe->GetNModules())
boxTop    = FLTARR(env.recipe->GetNFiletypes() + env.recipe->GetNModules())
j = 0
FOR i = 0, env.recipe->GetNFiletypes() - 1 DO BEGIN
    ft = env.recipe->GetFiletype(i)
    nodeBox = ft->GetBox()
    boxLeft[j]   = nodeBox[0]
    boxBottom[j] = nodeBox[1]
    boxRight[j]  = nodeBox[0] + nodeBox[2]
    boxTop[j]    = nodeBox[1] + nodeBox[3]
    j++
END
FOR i = 0, env.recipe->GetNModules() - 1 DO BEGIN
    m = env.recipe->GetModule(i)
    nodeBox = m->GetBox()
    boxLeft[j]   = nodeBox[0]
    boxBottom[j] = nodeBox[1]
    boxRight[j]  = nodeBox[0] + nodeBox[2]
    boxTop[j]    = nodeBox[1] + nodeBox[3]
    j++
END
vpX = MIN(boxLeft) - 0.25
vpY = MIN(boxBottom) - 0.25
vpW = MAX(boxRight) + 0.25 - vpX
vpH = MAX(boxTop) + 0.25 - vpY
self.fcView = OBJ_NEW('IDLgrView', COLOR=[255, 255, 255], UNITS=0, VIEWPLANE_RECT=[vpX, vpY, vpW, vpH])
self.fcWin->SetProperty, GRAPHICS_TREE=self.fcView
self.fcGraph = OBJ_NEW('IDLgrModel')
self.fcView->ADD, self.fcGraph
; create all filetype nodes
FOR i = 0, env.recipe->GetNFiletypes() - 1 DO BEGIN
    ft = env.recipe->GetFiletype(i)
    self->CreateNode, ft
END
; create all module nodes
FOR i = 0, env.recipe->GetNModules() - 1 DO BEGIN
    m = env.recipe->GetModule(i)
    self->CreateNode, m
    FOR j = 0, m->GetNInFiletypes() - 1 DO BEGIN
        self->CreateEdge, m->GetInFiletype(j), m
    END
    FOR j = 0, m->GetNOutFiletypes() - 1 DO BEGIN
        self->CreateEdge, m, m->GetOutFiletype(j)
    END
END
self.fcWin->DRAW, self.fcView
END

PRO ldrsFLOWCHART::RecipeLoaded, recipe
FOR i = 0, recipe->GetNModules() - 1 DO BEGIN
    m = recipe->GetModule(i)
    IF m->IsUsed() EQ 1 THEN BEGIN
        self->ModuleUsed, m
    ENDIF ELSE BEGIN
        self->ModuleUnused, m
    ENDELSE
END
END

PRO ldrsFLOWCHART__define
  struct = { ldrsFLOWCHART, $
             INHERITS ldrsVIEW, $
             fcWin:OBJ_NEW(), $
             fcView:OBJ_NEW(), $
             fcFont:OBJ_NEW(), $
             fcGraph:OBJ_NEW() $
             
           }
END
