FUNCTION ldrsIMGPOINT::Init, tool, nr, font
IF NOT self->ldrsIMGOBJ::Init(tool, nr, font) THEN RETURN, 0
PRINT, 'ldrsIMGPOINT::Init, col=', self.col
RETURN, 1
END

PRO ldrsIMGPOINT::SetLabel, _REF_EXTRA=ex
self->ldrsIMGOBJ::SetLabel, _EXTRA=ex
IF OBJ_VALID(self.labelObj) THEN self.labelObj->SetProperty, STRINGS=self.label
END

PRO ldrsIMGPOINT::Update
s = 10.0
; update the label (only if requested)
IF self.labelFlag THEN BEGIN
    pos = [self.pX + s, self.pY, 1]
    ; create the label if neccessary and update the position
    IF NOT OBJ_VALID(self.labelObj) THEN BEGIN
        self.labelObj = OBJ_NEW('IDLgrText', self.label, $
                                COLOR=self.col, $
                                LOCATIONS=pos, $
                                RECOMPUTE_DIMENSIONS=1, $
                                FONT=self.font)
        self->ADD, self.labelObj
    ENDIF ELSE BEGIN
        self.labelObj->SetProperty, LOCATIONS=pos
    ENDELSE
ENDIF
; update the cross (only if requested)
IF self.crossFlag THEN BEGIN
    pos = [[-1.0, 0.0], [0.0, -1.0], [1.0, 0.0], [0.0, 1.0]]*s
    pos[0, *] += self.pX
    pos[1, *] += self.pY
    ; create the cross if neccessary and update the position
    IF NOT OBJ_VALID(self.crossObj) THEN BEGIN
        self.crossObj = OBJ_NEW('IDLgrPolyline', pos, $
                                POLYLINES=[2, 0, 2, 2, 1, 3], $
                                THICK=2, COLOR=self.col)
        self->ADD, self.crossObj
    ENDIF ELSE BEGIN
        self.crossObj->SetProperty, DATA=pos
    ENDELSE
ENDIF
END

PRO ldrsIMGPOINT::AdjustCenter, proc
view = self.otool->GetView()
view->GetImage, image, z
self->GetCenter, x, y
CALL_PROCEDURE, proc, *image, x, y, z, cx, cy
self->SetCenter, cx, cy
END

PRO ldrsIMGPOINT::GetCenter, cx, cy
cx = self.pX
cy = self.pY
END

PRO ldrsIMGPOINT::SetCenter, cx, cy
self.pX = cx
self.pY = cy
END

PRO ldrsIMGPOINT::Move, dx, dy
self->SetPosition, self.pX + dx, self.pY + dy
END

PRO ldrsIMGPOINT::GetPosition, x, y
x = self.pX
y = self.pY
END

PRO ldrsIMGPOINT::SetPosition, x, y, ADJUST=adj, CENTER_PROC=cp
IF NOT KEYWORD_SET(adj) THEN adj = 0
self.pX = x
self.pY = y
IF adj NE 0 THEN self->AdjustCenter, cp
self->Update
END

PRO ldrsIMGPOINT::ChangeColor, col
IF self.labelFlag THEN self.labelObj->SetProperty, COLOR=col
IF self.crossFlag THEN self.crossObj->SetProperty, COLOR=col
END

PRO ldrsIMGPOINT::Store, cfg
cfg->SetFloat2D, 'POS', self.pX, self.pY
END

PRO ldrsIMGPOINT::Load, cfg
cfg->GetFloat2D, 'POS', x, y
self.pX = x
self.pY = y
self->Update
END

PRO ldrsIMGPOINT__define
  struct = { ldrsIMGPOINT, $
             INHERITS ldrsIMGOBJ, $
             pX:0.0, pY:0.0, $
             labelFlag:0, labelObj:OBJ_NEW(), $
             crossFlag:0, crossObj:OBJ_NEW() $
           }
END
