FUNCTION ldrsOBJCREATION::Init, algorithm
IF NOT self->ldrsEXTRACTION::Init(algorithm) THEN RETURN, 0
self.content = 2
self.dlgTitle = 'Target Creation Setup'
self.intFT = self.recipe->FindFiletype('PRE')
self.objFT = self.recipe->FindFiletype('TAR')
self.nResults = 2
RETURN, 1
END

FUNCTION ldrsOBJCREATION::Prepare
PRINT, 'ldrsOBJCREATION::Prepare'
IF NOT self->ldrsEXTRACTION::Prepare() THEN RETURN, 0
IF NOT self->CheckInputFiles(self.intFT, 1, 10) THEN RETURN, 0
; we need exactly one target file which contains all targets
IF NOT self->CheckOutputFiles(self.objFT, 1, 1) THEN RETURN, 0
RETURN, 1
END

FUNCTION ldrsOBJCREATION::Execute
PRINT, 'ldrsOBJCREATION::Execute:'
RETURN, self->ExtractPart(self.intFT, 'TARGET', self.objFT)
END

FUNCTION ldrsOBJCREATION::Finish
PRINT, 'ldrsOBJCREATION::Finish'
IF NOT self->ldrsEXTRACTION::Finish() THEN RETURN, 0
RETURN, self->StoreOutput(self.objFT)
END

PRO ldrsOBJCREATION::Load, cfg
self->ldrsEXTRACTION::Load, cfg
IF OBJ_VALID(cfg) THEN BEGIN
    self.nResults = cfg->GetInt('NRESULTS', DEFAULT=2)
    self.removeBgrd = cfg->GetInt('REMOVEBGRD', DEFAULT=0)
    self.useMask = cfg->GetInt('USEFFMASK', DEFAULT=0)
    self.recenter = cfg->GetInt('RECENTER', DEFAULT=0)
ENDIF ELSE BEGIN
    self.nResults = 2
    self.removeBgrd = 0
    self.useMask = 0
    self.recenter = 0
ENDELSE
END

PRO ldrsOBJCREATION::Store, cfg
self->ldrsEXTRACTION::Store, cfg
IF OBJ_VALID(cfg) THEN BEGIN
    cfg->SetInt, 'NRESULTS', self.nResults
    cfg->SetInt, 'REMOVEBGRD', self.removeBgrd
    cfg->SetInt, 'USEFFMASK', self.useMask
    cfg->SetInt, 'RECENTER', self.recenter
ENDIF
END

PRO ldrsOBJCREATION::ItemSelected, id, item
IF id EQ self.dNResults THEN self.nResults = item
END

PRO ldrsOBJCREATION::ReadDynamicContent
self->ldrsEXTRACTION::ReadDynamicContent
WIDGET_CONTROL, self.dNResults, SET_COMBOBOX_SELECT=self.nResults
WIDGET_CONTROL, self.dRemoveBgrd, SET_VALUE=[self.removeBgrd]
WIDGET_CONTROL, self.dUseMask, SET_VALUE=[self.useMask]
WIDGET_CONTROL, self.dRecenter, SET_VALUE=[self.recenter]
END

PRO ldrsOBJCREATION::WriteDynamicContent
self->ldrsEXTRACTION::WriteDynamicContent
WIDGET_CONTROL, self.dRemoveBgrd, GET_VALUE=flags
self.removeBgrd = flags[0]
WIDGET_CONTROL, self.dUseMask, GET_VALUE=flags
self.useMask = flags[0]
WIDGET_CONTROL, self.dRecenter, GET_VALUE=flags
self.recenter = flags[0]
END

PRO ldrsOBJCREATION::CreateContent
self->ldrsEXTRACTION::CreateContent
row = self->GetFreeRow()
lab              = self->CreateLabel(0, row, 'Add:', /HALIGN_RIGHT)
self.dNResults   = self->CreateComboBox(1, row, ['One', 'File', 'Image'])
row++
lab              = self->CreateLabel(0, row, 'Background:', /HALIGN_RIGHT)
self.dRemoveBgrd = self->CreateCheckbox(1, row, 'Remove')
row++
lab              = self->CreateLabel(0, row, 'Fourier Mask:', /HALIGN_RIGHT)
self.dUseMask    = self->CreateCheckbox(1, row, 'Use')
row++
lab              = self->CreateLabel(0, row, 'Centering:', /HALIGN_RIGHT)
self.dRecenter   = self->CreateCheckbox(1, row, 'Recenter')
row++
END

PRO ldrsOBJCREATION__define
struct = { ldrsOBJCREATION, $
           INHERITS ldrsEXTRACTION, $
           dNResults:0, dRemoveBgrd:0, dUseMask:0, dRecenter:0, $
           intFT:OBJ_NEW(), $
           objFT:OBJ_NEW() $
         }
END
