FUNCTION ldrsOBJTOOL::Init, view
IF NOT self->ldrsVIEWTOOL::Init(view) THEN RETURN, 0
fs = view->GetFontSize()
self.font = OBJ_NEW('IDLgrFont', SIZE=fs)
self.labelPrefix = '? '
RETURN, 1
END

FUNCTION ldrsOBJTOOL::GetImageFile
RETURN, self.imgFile
END

FUNCTION ldrsOBJTOOL::GetImageNr
RETURN, self.imgNr
END

PRO ldrsOBJTOOL::ReadDynamicContent
l = self.infoObj->GetLabel()
WIDGET_CONTROL, self.dLabel, SET_VALUE=l
END

PRO ldrsOBJTOOL::WriteDynamicContent
; It is not possible to overwrite the label!
END

PRO ldrsOBJTOOL::DoApply
self->ldrsVIEWTOOL::DoApply
self->UpdateObject, self.infoObj
self.view->Redraw
END

PRO ldrsOBJTOOL::CreateContent
self->ldrsVIEWTOOL::CreateContent
row = self->GetFreeRow()
lab              = self->CreateLabel(0, row, 'Label:', /HALIGN_RIGHT)
self.dLabel      = self->CreateEntry(2, row, VALUE='', XSIZE=8)
row++
END

FUNCTION ldrsOBJTOOL::CreateImageObject, onr
obj = OBJ_NEW(self.objClass, self, onr, self.font)
obj->SetLabel, PREFIX=self.labelPrefix
RETURN, obj
END

PRO ldrsOBJTOOL::CreateImageExtension, imgExt, file, nr
self.imgExt = imgExt
self.imgFile = file
self.imgNr = nr
cfg = file->GetImageCFG(nr)
IF NOT OBJ_VALID(cfg) THEN RETURN
cfg = cfg->Locate(self.cfgPlace, /NO_CREATE)
IF OBJ_VALID(cfg) THEN BEGIN
    cfgObj = cfg->GetFirst()
    WHILE OBJ_VALID(cfgObj) DO BEGIN
        onr = cfgObj->GetNr()
        obj = self->CreateImageObject(onr)
        obj->Load, cfgObj
        imgExt->ADD, obj
        cfgObj = cfgObj->GetNext()
    ENDWHILE
ENDIF
END

PRO ldrsOBJTOOL::Select, x, y
needRedraw=0
; deselect any previously selected reference star
IF OBJ_VALID(self.selObj) THEN BEGIN
    self.selObj->Deselect
    self.selObj = OBJ_NEW()
    needRedraw=1
ENDIF
selObj = self.view->Select(x, y)
selSpec = SIZE(selObj)
;PRINT, 'mouse click detected at (', event.x, ',', event.y, ')'
IF selSpec[0] EQ 0 THEN BEGIN
    PRINT, '   no object selected'
    IF needRedraw THEN self.view->Redraw
    RETURN
END
FOR i=0, selSpec[1]-1 DO BEGIN
    IF OBJ_ISA(selObj[i], self.objClass) THEN BEGIN
        self.selObj = selObj[i]
        self.selObj->Select
        needRedraw=1
        BREAK
    ENDIF
END
IF needRedraw THEN self.view->Redraw
END

PRO ldrsOBJTOOL::InitObject, obj, x, y
obj->SetPosition, x, y
END

; create a new image extension object at a specified position
PRO ldrsOBJTOOL::CreateObject, x, y
IF NOT OBJ_VALID(self.imgFile) THEN RETURN
cfg = self.imgFile->GetImageCFG(self.imgNr)
IF NOT OBJ_VALID(cfg) THEN RETURN
cfg = cfg->Locate(self.cfgPlace)
IF NOT OBJ_VALID(cfg) THEN RETURN
onr = cfg->GetNChilds() + 1
obj = self->CreateImageObject(onr)
self->InitObject, obj, x, y
self.imgExt->ADD, obj
self->UpdateObject, obj
self.view->Redraw
END

PRO ldrsOBJTOOL::UpdateObject, obj
; store the new position values in the configuration
cfg = self.imgFile->GetImageCFG(self.imgNr)
IF NOT OBJ_VALID(cfg) THEN RETURN
cfg = cfg->Locate(STRING(FORMAT='(A,I0)', self.cfgPlace, obj->GetNr()))
IF NOT OBJ_VALID(cfg) THEN RETURN
obj->Store, cfg
self->ObjectChanged, obj
END

; delete a tool object and rearrange and update the remaining
; tool objects
PRO ldrsOBJTOOL::DeleteObject, obj
; remove the tool object from the image
self.imgExt->Remove, obj
; remove the last (!) entry in the configuration
cfg = self.imgFile->GetImageCFG(self.imgNr)
IF NOT OBJ_VALID(cfg) THEN RETURN
cfgObj = cfg->Locate(self.cfgPlace, /NO_CREATE)
IF OBJ_VALID(cfgObj) THEN OBJ_DESTROY, cfgObj->GetLast()
IF self.selObj EQ obj THEN self.selObj = OBJ_NEW()
; delete the graphic object
OBJ_DESTROY, obj
; renumber the remaining reference stars
ie = self.imgExt->Get(/ALL, COUNT=iecnt)
nr = 1
FOR i=0,iecnt-1 DO BEGIN
    IF NOT OBJ_ISA(ie[i], self.objClass) THEN CONTINUE
    ie[i]->SetLabel, NR=nr
    self->UpdateObject, ie[i]
    nr += 1
ENDFOR
self.view->Redraw
END

PRO ldrsOBJTOOL::PressMiddle, modifiers, x, y
IF modifiers NE 0 THEN BEGIN
    self->ldrsVIEWTOOL::PressMiddle, modifiers, x, y
    RETURN
ENDIF
self->Select, x, y
IF NOT OBJ_VALID(self.selObj) THEN RETURN
self.moveFlag = 1
self.refX = x
self.refY = y
self.selObj->Edit, self.top
END

PRO ldrsOBJTOOL::Move, modifiers, x, y
IF modifiers NE 0 THEN BEGIN
    self->ldrsVIEWTOOL::Move, modifiers, x, y
    RETURN
ENDIF
IF NOT self.moveFlag THEN RETURN
self.view->RelToUser, x - self.refX, y - self.refY, dx, dy
self.selObj->Move, dx, dy
self.refX = x
self.refY = y
self.view->Redraw
END

PRO ldrsOBJTOOL::ReleaseMiddle, modifiers, x, y
IF modifiers NE 0 THEN BEGIN
    self->ldrsVIEWTOOL::ReleaseMiddle, modifiers, x, y
    RETURN
ENDIF
IF NOT self.moveFlag THEN RETURN
self.moveFlag = 0
self->UpdateObject, self.selObj
END

PRO ldrsOBJTOOL::ReleaseLeft, modifiers, x, y
CASE modifiers OF
    0: BEGIN
        self.view->AbsToUser, x, y, ux, uy
        self->CreateObject, ux, uy
    END
    1: self->ldrsVIEWTOOL::ReleaseLeft, modifiers, x, y
    2: BEGIN
        self->Select, x, y
        IF NOT OBJ_VALID(self.selObj) THEN RETURN
        self.selObj->Enlarge
        self->UpdateObject, self.selObj
        self.view->Redraw
    END
    ELSE:
ENDCASE
END

PRO ldrsOBJTOOL::ReleaseRight, modifiers, x, y
COMMON ldrs_img, ienv
CASE modifiers OF
    0: BEGIN
        self->Select, x, y
        IF NOT OBJ_VALID(self.selObj) THEN RETURN
        self->DeleteObject, self.selObj
    END
    1: self->ldrsVIEWTOOL::ReleaseRight, modifiers, x, y
    2: BEGIN
        self->Select, x, y
        IF NOT OBJ_VALID(self.selObj) THEN RETURN
        self.selObj->Shrink
        self->UpdateObject, self.selObj
        self.view->Redraw
    END
    ELSE:
ENDCASE
END

PRO ldrsOBJTOOL__define
struct = { ldrsOBJTOOL, $
           INHERITS ldrsVIEWTOOL, $
           cfgPlace:'', $
           objClass:'', $
           labelPrefix:'', $
           font:OBJ_NEW(), $
           imgExt:OBJ_NEW(), $
           imgFile:OBJ_NEW(), $
           imgNr:0, $
           selObj:OBJ_NEW(), $
           moveFlag:0, $
           dLabel:0 $
         }
END
