FUNCTION ldrsPROBETOOL::Init, view
IF NOT self->ldrsAREATOOL::Init(view) THEN RETURN, 0
self.dlgTitle = 'Probe'
self.cfgPlace = 'PROBE'
self.objClass = 'ldrsPROBE'
self.labelPrefix = 'Probe '
self.mMode = 3
RETURN, 1
END

PRO ldrsPROBETOOL::InitObject, obj, x, y
self->ldrsAREATOOL::InitObject, obj, x - 32.0, y - 32.0
obj->SetSize, WIDTH=64.0, HEIGHT=64.0
END

PRO ldrsPROBETOOL::UpdateCalculatedValues
; recalculate the values
self.infoObj->GetTotal, v, s
WIDGET_CONTROL, self.dTotal, SET_VALUE=STRING(v)
WIDGET_CONTROL, self.dSize, SET_VALUE=STRING(s)
self.infoObj->GetMin, v, x, y
WIDGET_CONTROL, self.dMin, SET_VALUE=STRING(v)
WIDGET_CONTROL, self.dMinX, SET_VALUE=STRING(x)
WIDGET_CONTROL, self.dMinY, SET_VALUE=STRING(y)
self.infoObj->GetMax, v, x, y
WIDGET_CONTROL, self.dMax, SET_VALUE=STRING(v)
WIDGET_CONTROL, self.dMaxX, SET_VALUE=STRING(x)
WIDGET_CONTROL, self.dMaxY, SET_VALUE=STRING(y)
self.infoObj->GetPeak, x, y
WIDGET_CONTROL, self.dCenterX, SET_VALUE=STRING(x)
WIDGET_CONTROL, self.dCenterY, SET_VALUE=STRING(y)
WIDGET_CONTROL, self.dMean, SET_VALUE=STRING(self.infoObj->GetMean())
WIDGET_CONTROL, self.dMedian, SET_VALUE=STRING(self.infoObj->GetMedian())
WIDGET_CONTROL, self.dVariance, SET_VALUE=STRING(self.infoObj->GetVariance())
WIDGET_CONTROL, self.dSkew, SET_VALUE=STRING(self.infoObj->GetSkew())
WIDGET_CONTROL, self.dKurt, SET_VALUE=STRING(self.infoObj->GetKurtosis())
END

PRO ldrsPROBETOOL::ReadDynamicContent
self->ldrsAREATOOL::ReadDynamicContent
self->UpdateCalculatedValues
END

PRO ldrsPROBETOOL::WriteDynamicContent
self->ldrsAREATOOL::WriteDynamicContent
self->UpdateCalculatedValues
END

PRO ldrsPROBETOOL::DoUpdate
self->ReadDynamicContent
END

PRO ldrsPROBETOOL::CreateContent
self->ldrsAREATOOL::CreateContent
row = self->GetFreeRow()
lab             = self->CreateLabel(0, row, 'Total:', /HALIGN_RIGHT)
lab             = self->CreateLabel(1, row, 'integral', /HALIGN_RIGHT)
self.dTotal     = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'area', /HALIGN_RIGHT)
self.dSize      = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(0, row, 'Peaks:', /HALIGN_RIGHT)
lab             = self->CreateLabel(1, row, 'x=', /HALIGN_RIGHT);
self.dMinX      = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'y=', /HALIGN_RIGHT);
self.dMinY      = self->CreateEntry(4, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(5, row, 'min=', /HALIGN_RIGHT);
self.dMin       = self->CreateEntry(6, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(1, row, 'x=', /HALIGN_RIGHT);
self.dMaxX      = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'y=', /HALIGN_RIGHT);
self.dMaxY      = self->CreateEntry(4, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(5, row, 'max=', /HALIGN_RIGHT);
self.dMax       = self->CreateEntry(6, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(0, row, 'Centroid:', /HALIGN_RIGHT)
lab             = self->CreateLabel(1, row, 'x=', /HALIGN_RIGHT);
self.dCenterX   = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'y=', /HALIGN_RIGHT);
self.dCenterY   = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(0, row, 'Statistics:', /HALIGN_RIGHT)
lab             = self->CreateLabel(1, row, 'median=', /HALIGN_RIGHT);
self.dMedian    = self->CreateEntry(2, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(1, row, 'mean=', /HALIGN_RIGHT);
self.dMean      = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'var=', /HALIGN_RIGHT);
self.dVariance  = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(1, row, 'skew=', /HALIGN_RIGHT);
self.dSkew      = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'kurtosis=', /HALIGN_RIGHT);
self.dKurt      = self->CreateEntry(4, row, VALUE=STRING(0.0))
END

PRO ldrsPROBETOOL::CreateButtons
self->ldrsDIALOG::CreateButtons
self.dlgUpdateButton = WIDGET_BUTTON(self.dlgButtons, VALUE='Update', EVENT_PRO='LDRS_DIALOG_UPDATE', UVALUE=self)
END

PRO ldrsPROBETOOL__define
struct = { ldrsPROBETOOL, $
           INHERITS ldrsAREATOOL, $
           dlgUpdateButton:0, $
           dTotal:0, dSize:0, $
           dCenterX:0, dCenterY:0, $
           dMin:0, dMinX:0, dMinY:0, $
           dMax:0, dMaxX:0, dMaxY:0, $
           dMean:0, dMedian:0, dVariance:0, dSkew:0, dKurt:0 $
         }
END

