FUNCTION ldrsPSFTOOL::Init, view
IF NOT self->ldrsAREATOOL::Init(view) THEN RETURN, 0
self.dlgTitle = 'Psf'
self.cfgPlace = 'PSFSTAR'
self.objClass = 'ldrsPSFSTAR'
self.labelPrefix = 'Psf '
self.mMode = 1
RETURN, 1
END

PRO ldrsPSFTOOL::InitObject, obj, x, y
;self->ldrsOBJTOOL::InitObject, obj, x, y
proc = LDRS_GET_PROCEDURE('CALCCENTER', self.posAlgo)
obj->SetPosition, x, y, /ADJUST, CENTER_PROC=proc
obj->SetMargins, 128, 128, 128, 128
END

PRO ldrsPSFTOOL::ReadDynamicContent
self->ldrsAREATOOL::ReadDynamicContent
self.infoObj->GetHalo, haloAlgo
self.haloAlgo = haloAlgo
WIDGET_CONTROL, self.dHaloAlgo, SET_COMBOBOX_SELECT=haloAlgo
self.infoObj->GetExtrapolation, epolAlgo
self.epolAlgo = epolAlgo
WIDGET_CONTROL, self.dEpolAlgo, SET_COMBOBOX_SELECT=epolAlgo
self.infoObj->GetDimension, nxy
self.nxy = nxy
WIDGET_CONTROL, self.dNXY, SET_VALUE=STRING(self.nxy)
END

PRO ldrsPSFTOOL::WriteDynamicContent
self->ldrsAREATOOL::WriteDynamicContent
self.infoObj->SetHalo, self.haloAlgo
self.infoObj->SetExtrapolation, self.epolAlgo
WIDGET_CONTROL, self.dNXY, GET_VALUE=str1
self.nxy = FIX(str)
self.infoObj->SetDimension, self.nxy
END

PRO ldrsPSFTOOL::ItemSelected, id, item
self->ldrsAREATOOL::ItemSelected, id, item
IF id EQ self.dHaloAlgo THEN self.haloAlgo = item
IF id EQ self.dEpolAlgo THEN self.epolAlgo = item
END

PRO ldrsPSFTOOL::SetHalo, id, item
self.haloAlgo = item
END

PRO ldrsPSFTOOL::SetExtrapolation, id, item
self.epolAlgo = item
END

PRO ldrsPSFTOOL::CreateContent
self->ldrsAREATOOL::CreateContent
row = self->GetFreeRow()
lab              = self->CreateLabel(0, row, 'Halo:', /HALIGN_RIGHT)
self.dHaloAlgo   = self->CreateProcedureMenu(2, row, 'HALOC', 'SetHalo')
row++
lab              = self->CreateLabel(0, row, 'Extrapolation:', /HALIGN_RIGHT)
self.dEpolAlgo   = self->CreateProcedureMenu(2, row, 'PSFEXT', 'SetExtrapolation')
lab              = self->CreateLabel(3, row, 'Size=', /HALIGN_RIGHT)
self.dNXY        = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
END

PRO ldrsPSFTOOL__define
struct = { ldrsPSFTOOL, $
           INHERITS ldrsAREATOOL, $
           dHaloAlgo:0, dEpolAlgo:0, dNXY:0, $
           haloAlgo:-1, epolAlgo:-1, nxy:0 $
         }
END

