FUNCTION ldrsVIEW::Init, cfg, frame
self.frame = frame
self.label = cfg->GetString('LABEL')
cfg->GetInt2D, 'SCRSIZE', w, h
self.scrSize = [w, h]
self.fontSize = cfg->GetFloat('FONTSIZE')
RETURN, 1
END

FUNCTION ldrsVIEW::GetFontSize
RETURN, self.fontSize
END

PRO ldrsVIEW::RecipeLoaded, recipe
END

PRO ldrsVIEW::ModuleSelected, module
END

PRO ldrsVIEW::ModuleDeselected, module
END

PRO ldrsVIEW::AlgorithmSelected, algorithm
END

PRO ldrsVIEW::AlgorithmDeselected, algorithm
END

PRO ldrsVIEW::FiletypeSelected, filetype
END

PRO ldrsVIEW::FiletypeDeselected, filetype
END

PRO ldrsVIEW::FiletypeChanged, filetype
END

PRO ldrsVIEW::PrefixChanged, filetype
END

PRO ldrsVIEW::FileSelected, file
END

PRO ldrsVIEW::FileDeselected, file
END

PRO ldrsVIEW::FileCreated, file
END

PRO ldrsVIEW::FileChanged, file
END

PRO ldrsVIEW::FileLoaded, file
END

PRO ldrsVIEW::FileRemoved, filetype
END

PRO ldrsVIEW::ImageSelected, image
END

PRO ldrsVIEW::ImageDeselected, image
END

PRO ldrsVIEW::ImageChanged, file, image
END

PRO ldrsVIEW::CreateLabel, cfgPanel
self.guiLabel = WIDGET_LABEL(self.guiBase, VALUE=self.label)
END

PRO ldrsVIEW::CreateContent, cfgPanel
self.guiPanel = WIDGET_BASE(self.guiBase, /COLUMN, SPACE=0, XPAD=0, YPAD=0, $
                            SCR_XSIZE=self.scrSize[0], SCR_YSIZE=self.scrSize[1])
END

PRO ldrsVIEW::CreateButtons, cfgPanel
bcfg = cfgPanel->Locate('ITEM')
IF OBJ_VALID(bcfg) THEN BEGIN
    btnBase = WIDGET_BASE(self.guiBase, /ROW)
    cfgBtn = bcfg->GetFirst()
    WHILE OBJ_VALID(cfgBtn) DO BEGIN
        btnLabel = cfgBtn->GetString('LABEL')
        btnPro = cfgBtn->GetString('PRO')
        IF btnPro EQ '' THEN BEGIN
            btn = WIDGET_BUTTON(btnBase, VALUE=btnLabel, EVENT_PRO='LDRS_NYI_EVENT', /SENSITIVE)
        END ELSE BEGIN
            btn = WIDGET_BUTTON(btnBase, VALUE=btnLabel, EVENT_PRO=btnPro, /SENSITIVE)
        END
        self->AddButton, btn
        cfgBtn = cfgBtn->GetNext()
    ENDWHILE
END
END

PRO ldrsVIEW::CreateGUI, base, cfgPanel
self.guiBase = WIDGET_BASE(base, /COLUMN, /FRAME, SPACE=0, XPAD=0, YPAD=0)
self->CreateLabel, cfgPanel
self->CreateContent, cfgPanel
self->CreateButtons, cfgPanel
END

PRO ldrsVIEW::RealizeGUI
END

FUNCTION ldrsVIEW::Resize, dw, dh
RETURN, 0
END

PRO ldrsVIEW::AddButton, btn
self.guiBtns[self.guiNBtns] = btn
self.guiNBtns += 1
END

PRO ldrsVIEW::DisableButtons
FOR i=0, self.guiNBtns-1 DO BEGIN
    WIDGET_CONTROL, self.guiBtns[i], SENSITIVE=0
ENDFOR
END

PRO ldrsVIEW::EnableButtons
FOR i=0, self.guiNBtns-1 DO BEGIN
    WIDGET_CONTROL, self.guiBtns[i], SENSITIVE=1
ENDFOR
END

PRO ldrsVIEW::ShowInfo, info
self.frame->ShowInfo, info
END

PRO ldrsVIEW__define
  struct = { ldrsVIEW, $
             frame:OBJ_NEW(), $
             label:'', $
             scrSize:[250, 250], $
             fontSize:0.0, $
             guiBase:0, $
             guiLabel:0, $
             guiPanel:0, $
             guiNBtns:0, $
             guiBtns:INTARR(10) $
           }
END
